package com.example.samsungpay;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import com.samsung.android.sdk.samsungpay.v2.PartnerInfo;
import com.samsung.android.sdk.samsungpay.v2.SamsungPay;
import com.samsung.android.sdk.samsungpay.v2.SpaySdk;
import com.samsung.android.sdk.samsungpay.v2.payment.PaymentManager;

import java.lang.ref.WeakReference;

public class SampleAppPartnerInfoHolder {
    private Context mContext;
    private static WeakReference<SampleAppPartnerInfoHolder> sInstance;

    private PartnerInfo mPartnerInfo;
    private int mSpayNotReadyReason;
    public PartnerInfo getPartnerInfo() {
        SharedPreferences sharedPref = PreferenceManager.getDefaultSharedPreferences(mContext);
        boolean isTestModeEnabled = sharedPref.getBoolean(mContext.getString(R.string.pref_key_test_mode), false);
        if (isTestModeEnabled) {
            mPartnerInfo.getData().putBoolean(PaymentManager.EXTRA_KEY_TEST_MODE, true);
        }
        return mPartnerInfo;
    }

    SampleAppPartnerInfoHolder(Context context) {
        mContext = context;
        Bundle bundle = new Bundle();
        bundle.putString(SamsungPay.PARTNER_SERVICE_TYPE, SpaySdk.ServiceType.INAPP_PAYMENT.toString());
        mPartnerInfo = new PartnerInfo(mContext.getString(R.string.gradle_product_id), bundle);
        sInstance = new WeakReference<>(this);
    }

    public static SampleAppPartnerInfoHolder getInstance() {
        return sInstance.get();
    }

    String getSampleAppName() {
        return mContext.getString(R.string.sample_app_name);
    }

    void setSpayNotReadyStatus(int reason) {
        mSpayNotReadyReason = reason;
    }

    int getSpayNotReadyStatus() {
        return mSpayNotReadyReason;
    }
}